module FastshopCatalog
  class CheckAvailabilityService < FastshopCatalog::BaseService

    def initialize
      @service = :consulta_disponibilidade
      @interface = 'IConsultaDisponibilidade'
      @soap_method = :retorna_dados
      @return_key = 'Disponibilidade'
      super(:namespaces => {'xmlns:fas' => 'http://schemas.datacontract.org/2004/07/FastServices.WsConsultaDisponibilidade.Componentes'})
    end

    def check(order)
      root_attributes = order.to_map
      adapted_items = []
      root_attributes['Itens'].each do |item|
        adapted_items << {'fas:PedidoItensEntity' => adapt_output(item.to_map, 'fas')}
      end
      root_attributes['Itens'] = adapted_items
      service_invoker('dadosPedido' => adapt_output(root_attributes, 'fas'))
    end

  end
end
