module FastshopCatalog
  class OrderPlacementService < FastshopCatalog::BaseService

    def initialize
      @service = :colocacao_pedido
      @interface = 'IColocacaoPedido'
      @soap_method = :incluir_pedido
      @return_key = 'NumeroPedidoFast'
      super
    end

    def place_order(order)
      payload = order.to_map
      items = []
      payload["Itens"].each do |item|
        items << item.to_map
      end
      payload["Itens"] = items
      payload = payload.to_json
      AUX_LOG.debug('Order as json: ' + payload)
      service_invoker_with_encryption('entrada', 'contrato' => order.contract_code,
      'entrada' => payload)
    end

  end
end
