module FastshopCatalog
  class ServiceUrls
    DEFAULT_BASE_URL = 'http://www.fastincentivos.com.br'

    PRODUCTION_URLS = {
      catalogo: "http://www.fastincentivos.com.br:8081/Catalogo.svc/service",
      consulta_disponibilidade: "http://www.fastincentivos.com.br:8084/ConsultaDisponibilidade.svc/service",
      consulta_dne_externo: "http://www.fastincentivos.com.br:8086/ConsultaDneExterno.svc/service",
      colocacao_pedido: "http://www.fastincentivos.com.br:8082/ColocacaoPedido.svc/service",
      consulta_status: "http://www.fastincentivos.com.br:8090/ConsultaStatusPedido.svc/service",
      participante: "http://www.fastincentivos.com.br:8093/Participante.svc/service",
      consulta_produto: "#{DEFAULT_BASE_URL}/FastServices.WsConsultaProduto/ConsultaProduto.svc/service"
    }

    HOMOLOG_URLS = {
      catalogo: "#{DEFAULT_BASE_URL}/FastServices.WsCatalogo/Catalogo.svc/service",
      consulta_disponibilidade: "#{DEFAULT_BASE_URL}/FastServices.WsConsultaDisponibilidade/ConsultaDisponibilidade.svc/service",
      consulta_dne_externo: "#{DEFAULT_BASE_URL}/FastServices.WsConsultaDneExterno/ConsultaDneExterno.svc/service",
      colocacao_pedido: "#{DEFAULT_BASE_URL}/FastServices.WsColocacaoPedido/ColocacaoPedido.svc/service",
      consulta_status: "#{DEFAULT_BASE_URL}/FastServices.WsConsultaStatusPedido/ConsultaStatusPedido.svc/service",
      participante: "#{DEFAULT_BASE_URL}/FastServices.WsParticipante/Participante.svc/service",
      consulta_produto: "#{DEFAULT_BASE_URL}/FastServices.WsConsultaProduto/ConsultaProduto.svc/service"
    }
    attr_reader :env

    def initialize(env)
      @env = env
    end

    def url_for(serv)
      url = ""
      if env == "production"
        url = PRODUCTION_URLS.fetch(serv)
      else
        url = HOMOLOG_URLS.fetch(serv)
      end

      url
    end
  end
end